#<profile4xi profile = "11" />  
# -------------------------------------------------------------------------------------------------
#<program4xi program = "zap0200one4xi.py">
#<abstract4xi abstract = "zaps to direction one"/>
#<verify4xi verification = "11" target = "zap2actor4xi.py"/>
#<refer4xi reference = "zap2actor4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'zap0200one4xi']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import itertools
import logging 
import os
import threading                
import signal
import sys
from math import pi
from math import sin
from math import cos 
from math import fabs
import weakref
import _thread
import _winapi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from zap2module4xi import ModuleKB2Zap4Xi
from print4xi      import print4xi
from time4xi       import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
# do NO define any globals for this kind of multiprocessing/thread module !!
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
ack2dragontrace = False 
#" 
#"/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "zap0200one4xi" usage = "target function for zap0000one4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
def zap0200one4xi(queue0200one, consumer_channel0200one, publisher_channel0200one, kb0200one):  
    '''
    returns layer 0200 of direction one
    ''' 
    # -------------------------------------------------------------------------------------------------
    # (Step 1/33)             
    # -------------------------------------------------------------------------------------------------   
    class2print  = 'zap0200one4xi'
    method2print = 'zap0200one4xi'
        
    # -------------------------------------------------------------------------------------------------
    # (Step 2/33)                      
    # -------------------------------------------------------------------------------------------------                                                               
    if ack2debug is True:
        print("\n (Step 2A/33) OF ZAP0200ONE4XI - STARTED TIME: ", time4xi())                                      # 
        print("\n (Step 2B/33) OF ZAP0200ONE4XI -  QUEUE0200ONE: ", queue0200one)                                  # <queue4xi.Queue4Xi object at 0x0A7CAA50>
        print("\n (Step 2C/33) OF ZAP0200ONE4XI -  CONSUME_CHANNEL0200ONE: ", consumer_channel0200one)             # 
        print("\n (Step 2D/33) OF ZAP0200ONE4XI -  PUBLISHER_CHANNEL0200ONE: ", publisher_channel0200one)          # 
        print("\n (Step 2E/33) OF ZAP0200ONE4XI -  KB2ONE: ", kb0200one)                                              
        # 
        
        
    if ack2dragontrace is True:
        message2print = "{(Step 2A/33) started" + "; zap0200one4xi-started: " + str(zap0200one4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              # 
        
        message2print = "{(Step 2B/33) passed" + "; queue0200one-passed-to-zap0200one4xi: " + str(queue0200one) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              # 
                      
        message2print = "{(Step 2C/33) passed" + "; consumer-channel0200one-passed-to-zap0200one4xi: " + str(consumer_channel0200one) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              #     
        
        message2print = "{(Step 2D/33) passed" + "; publisher-channel0200one-passed-to-zap0200one4xi: " + str(publisher_channel0200one) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              #        
        
        message2print = "{(Step 2E/33) passed" + "; kb0200one-passed-to-zap0200one4xi: " + str(kb0200one) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'0x2y199z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon0x2y199z', 5: '#9BA2A2', 6: 289, 7: 1, 8: Decimal('199.010049997'), 9: Decimal('0'), 10: 1, 11: '{returning; set-close-process4xi-returning: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_close_process4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #  '0x5y99z': {'2xi': {1: 1, 2: 100, 3: {1: 15707.963267948966, 2: '#848484', 3: 32, 4: 490.8738521234052}, 4: 'dragon0x5y99z', 5: '#9BA2A2', 6: 157, 7: 1, 8: Decimal('99.1261822124'), 9: Decimal('0'), 10: 1, 11: '{passed; set-initial-process4xi-param-passed-to-set-initial-process4xi: initial_new; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_initial_process4xi', 13: 1}, '8xi': {}, '4xi': {}},
        #  '139x315y202z': {'2xi': {1: 1, 2: 400, 3: {1: 251327.41228718346, 2: '#848484', 3: 32, 4: 7853.981633974483}, 4: 'dragon139x315y202z', 5: '#9BA2A2', 6: 424, 7: 1, 8: Decimal('399.186673124'), 9: Decimal('0'), 10: 1, 11: '{set; terminate_process4xi-set-by-set-terminate-process4xi to: 222; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_terminate_process4xi', 13: 1}, '8xi': {}, '4xi': {}},
        # ...
    
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # (Step 3/33)
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if ack2debug is True:
        print("\n (Step 3/33) OF ZAP0200ONE4XI - TRYING TO PUT LAYER 0200 TO QUEUE0200ONE: ", queue0200one)         # 
    if ack2dragontrace is True:
        message2print = "{(Step 3/33) using" + "; queue0200one-using-by-zap0200one4xi: " + str(queue0200one)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                              #  
            
    ack0200put4one = False                                                                                                                           

    # ------------------------------------------------------------------------------------- 
    # (Step 4/33) 
    # -------------------------------------------------------------------------------------                 

    # ------------------------------------------------------------------------------------- 
    # CONSTANTS VALID FOR ANY ZAP-KOWLEDGEBASE  
    # -------------------------------------------------------------------------------------     
    key2sense       = '2xi'
    key2reason      = '4xi'
    key2ace         = '8xi'
    key2direction   = 1
    key2distance    = 2
    key2layer       = 3
    
    key2area4layer  = 1
    key2color4layer = 2
    key2qty4layer   = 3
    key2area4node   = 4
    
    key2identity    = 4 
    key2color       = 5
    key2fire        = 6
    key2cluster     = 7
    key2ray         = 8
    key2deviation   = 9 
    key2super       = 10
    key2message     = 11
    key2actor       = 12
    key2type        = 13
    key2home        = 14
    key2previous    = 15
    key2next        = 16
    key2last        = 17
    key2first       = 18
    key2module      = 19
      
    # ------------------------------------------------------------------------------------- 
    # (Step 5/33) CONSTANTS VALID FOR LAYER 0200 OF DIRECTION ONE 
    # ------------------------------------------------------------------------------------- 
    direction0200sense4one = 1                                                                                                      # DIRECTION
    if ack2dragontrace is True:
        message2print = "{(Step 5A/33) set" + "; direction0200sense4one-set-by-zap0200one4xi to: " + str(direction0200sense4one)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                              # 1  
            
    distance0200sense4one  = 200                                                                                                     # DISTANCE = LAYER
    if ack2dragontrace is True:
        message2print = "{(Step 5B/33) set" + "; distance0200sense4one-set-by-zap0200one4xi to: " + str(distance0200sense4one)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                              # 
                                                                 
    # ------------------------------------------------------------------------------------- 
    # (Step 6/33) CREATE NEW KNOWLEDGEBASE FOR LAYER 0200 OF DIRECTION ONE 
    # -------------------------------------------------------------------------------------         
    keys0200one = kb0200one.keys()
    kb0200one2put = {}
    for key0200one in keys0200one:
        if ((kb0200one[key0200one] [key2sense] [key2distance] == distance0200sense4one) and (kb0200one[key0200one] [key2sense] [key2direction] == direction0200sense4one)):
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------        
            if ack2debug is True:
                print("\n (Step 6A0/33) OF ZAP0200ONE4XI - LEVEL NODE'S KEY: ", key0200one, " CONTENT: ", kb0200one[key0200one])
                                                                                                                                    # 0x2y199z 
            if ack2dragontrace is True:
                message2print = "{(Step 6A0/33) set" + "; nodekey-set-by-zap0200one4xi to: " + str(key0200one)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                      #            
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------         
            try:                                                                                                                    
                kb0200one2put [key0200one] = {}                                                                                     # SAVE THE LAYER OF THE REQUIRED DIRECTION
            except:
                print("\n (Step 6A/33) OF ZAP0200ONE4XI *** FAILED TO SET LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            try:         
                kb0200one2put [key0200one] [key2sense]  = {}                                                                        # SENSE
            except:
                print("\n (Step 6B/33) OF ZAP0200ONE4XI *** FAILED TO SET LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                   
            if ack2debug is True:
                print("\n (Step 6C/33) OF ZAP0200ONE4XI - TRYING TO SET key2direction: ", kb0200one [key0200one] [key2sense] )     # 
            try:                             
                kb0200one2put [key0200one] [key2sense] [key2direction] = kb0200one [key0200one] [key2sense] [key2direction]         # DIRECTION 
                if ack2dragontrace is True:
                    message2print = "{(Step 6D/33) set" + "; direction-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2direction])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  # 
                         
            except:
                print("\n (Step 6E/33) OF ZAP0200ONE4XI *** FAILED TO SET key2direction AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6F/33) OF ZAP0200ONE4XI - TRYING TO SET key2distance: ", kb0200one [key0200one] [key2sense] )      #                
            try:                             
                kb0200one2put [key0200one] [key2sense] [key2distance] = kb0200one [key0200one][key2sense] [key2distance]            # DISTANCE
                if ack2dragontrace is True:
                    message2print = "{(Step 6G/33) set" + "; distance-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2distance])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  # 
            except:
                print("\n (Step 6B4B/33) OF ZAP0200ONE4XI *** FAILED TO SET key2distance AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B5A/33) OF ZAP0200ONE4XI - TRYING TO SET key2layer: ", kb0200one [key0200one] [key2sense] )       #               
            try:                             
                kb0200one2put [key0200one] [key2sense] [key2layer] = {}                                                             # LAYER
                if ack2dragontrace is True:
                    message2print = "{(Step 6B4A/33) set" + "; layer-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2layer])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  # {}                 
            except:
                print("\n (Step 6B5B/33) OF ZAP0200ONE4XI *** FAILED TO SET key2layer AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B6A/33) OF ZAP0200ONE4XI - TRYING TO SET key2area4layer: ", kb0200one [key0200one]  [key2sense] [key2layer] )                   
            try:                                                                                                                    #                    
                kb0200one2put [key0200one] [key2sense] [key2layer] [key2area4layer] = kb0200one [key0200one] [key2sense] [key2layer] [key2area4layer] 
                                                                                                                                    # AREA2LAYER
                if ack2dragontrace is True:
                    message2print = "{(Step 6B4A/33) set" + "; area2layer-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2layer] [key2area4layer])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #                  
            except:
                print("\n (Step 6B6B/33) OF ZAP0200ONE4XI *** FAILED TO SET key2area4layer AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B7A/33) OF ZAP0200ONE4XI - TRYING TO SET key2color4layer: ", kb0200one [key0200one]  [key2sense] [key2layer]  )
                                                                                                                                    #                    
            try:                             
                kb0200one2put [key0200one] [key2sense] [key2layer] [key2color4layer] = kb0200one [key0200one] [key2sense] [key2layer] [key2color4layer]
                                                                                                                                    # COLOR2LAYER 
                if ack2dragontrace is True:
                    message2print = "{(Step 6B4A/33) set" + "; color2layer-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2layer] [key2color4layer])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B7B/33) OF ZAP0200ONE4XI *** FAILED TO SET key2color4layer AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B8A/33) OF ZAP0200ONE4XI - TRYING TO SET key2qty4layer: ", kb0200one [key0200one]  [key2sense] [key2layer]  )
                                                                                                                                    #                         
            try:                             
                kb0200one2put [key0200one] [key2sense] [key2layer] [key2qty4layer] = kb0200one [key0200one] [key2sense] [key2layer] [key2qty4layer]
                                                                                                                                    # QTY2LAYER
                if ack2dragontrace is True:
                    message2print = "{(Step 6B8B/33) set" + "; qty2layer-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2layer] [key2qty4layer])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B8C/33) OF ZAP0200ONE4XI *** FAILED TO SET key2qty4layer AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B9A/33) OF ZAP0200ONE4XI - TRYING TO SET key2area4layer: ", kb0200one  [key0200one] [key2sense] [key2layer]  )
                                                                                                                                    #                           
            try:                             
                kb0200one2put [key0200one] [key2sense] [key2layer] [key2area4node] = kb0200one [key0200one] [key2sense] [key2layer] [key2area4node]
                                                                                                                                    # AREA2NODE
                if ack2dragontrace is True:
                    message2print = "{(Step 6B9B/33) set" + "; area2node-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2layer] [key2area4node])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #             
            except:
                print("\n (Step 6B9C/33) OF ZAP0200ONE4XI *** FAILED TO SET key2area4layer AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B10A/33) OF ZAP0200ONE4XI - TRYING TO SET key2identity: ", kb0200one  [key0200one] [key2sense] )  #               
            try:                              
                kb0200one2put [key0200one] [key2sense] [key2identity] = kb0200one[ key0200one] [key2sense] [key2identity]           # IDENTITY
                if ack2dragontrace is True:
                    message2print = "{(Step 6B10B/33) set" + "; identity-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2identity])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B10C/33) OF ZAP0200ONE4XI *** FAILED TO SET key2identity AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B11A/33) OF ZAP0200ONE4XI - TRYING TO SET key2color: ", kb0200one [key0200one]  [key2sense] )     #               
            try:                              
                kb0200one2put [key0200one] [key2sense] [key2color] = kb0200one [key0200one]  [key2sense] [key2color]                # COLOR
                if ack2dragontrace is True:
                    message2print = "{(Step 6B4A/33) set" + "; color-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2color])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #                  
            except:
                print("\n (Step 6B11B/33) OF ZAP0200ONE4XI *** FAILED TO SET key2color AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B12A/33) OF ZAP0200ONE4XI - TRYING TO SET key2fire: ", kb0200one [key0200one]  [key2sense] )      # 
            try:                             
                kb0200one2put [key0200one] [key2sense] [key2fire] = kb0200one [key0200one]  [key2sense] [key2fire]                  # FIRE 
                if ack2dragontrace is True:
                    message2print = "{STEP 2B12A/33) set" + "; fire-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2fire])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  # 
                        
            except:
                print("\n (Step 6B12B/33) OF ZAP0200ONE4XI *** FAILED TO SET key2fire AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B13A/33) OF ZAP0200ONE4XI - TRYING TO SET key2cluster: ", kb0200one [key0200one]  [key2sense] )   # 
                                  
            try:                             
                kb0200one2put [key0200one] [key2sense] [key2cluster] = kb0200one [key0200one]  [key2sense] [key2cluster]            # CLUSTER
                if ack2dragontrace is True:
                    message2print = "{(Step 6B4A/33) set" + "; cluster-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2cluster])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #                  
            except:
                print("\n (Step 6B13B/33) OF ZAP0200ONE4XI *** FAILED TO SET key2cluster AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B14A/33) OF ZAP0200ONE4XI - TRYING TO SET key2ray: ", kb0200one [key0200one]  [key2sense] )       #               
            try:                             
                kb0200one2put[key0200one] [key2sense] [key2ray] = kb0200one [key0200one]  [key2sense] [key2ray]                     # RAY 
                if ack2dragontrace is True:
                    message2print = "{(Step 6B4A/33) set" + "; ray-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put[key0200one] [key2sense] [key2ray])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #                
            except:
                print("\n (Step 6B14B/33) OF ZAP0200ONE4XI *** FAILED TO SET key2ray AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B15A/33) OF ZAP0200ONE4XI - TRYING TO SET key2deviation: ", kb0200one [key0200one]  [key2sense] ) #                 
            try:                             
                kb0200one2put [key0200one] [key2sense] [key2deviation] = kb0200one [key0200one]  [key2sense] [key2deviation]        # DEVIATION
                if ack2dragontrace is True:
                    message2print = "{(Step 6B4A/33) set" + "; deviation-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2deviation])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #               
            except:
                print("\n (Step 6B15B/33) OF ZAP0200ONE4XI *** FAILED TO SET key2deviation AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B16A/33) OF ZAP0200ONE4XI - TRYING TO SET key2super: ", kb0200one [key0200one]  [key2sense] )     #                 
            try:                              
                kb0200one2put[key0200one] [key2sense] [key2super] = kb0200one [key0200one]  [key2sense] [key2super]                 # SUPER
                if ack2dragontrace is True:
                    message2print = "{(Step 6B4A/33) set" + "; super-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put[key0200one] [key2sense] [key2super])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #                  
            except:
                print("\n (Step 6B16B/33) OF ZAP0200ONE4XI *** FAILED TO SET key2super AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B17A/33) OF ZAP0200ONE4XI - TRYING TO SET key2message: ", kb0200one [key0200one]  [key2sense] )   #                
            try:                             
                kb0200one2put [key0200one] [key2sense] [key2message] = kb0200one [key0200one]  [key2sense] [key2message]            # MESSAGE
                if ack2dragontrace is True:
                    message2print = "{(Step 6B4A/33) set" + "; message-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2message])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  # 
                                 
            except:
                print("\n (Step 6B17C/33) OF ZAP0200ONE4XI - TRYING TO GENERATE DUMMY MESSAGE TO: ", kb0200one [key0200one]  [key2sense])     
                try:
                                                                                                                                    # set default message
                    kb0200one2put [key0200one] [key2sense] [key2message] = "{(Step 6B17C/33) yielded" + "; key2message-yielded-by-zap0200one4xi: " + str(key2message)  + "; time: " + time4xi() + "}"
                    
                    message2print = "{(Step 6B17D/33) set" + "; message-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2message])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 

                except:    
                    print("\n (Step 6B17Z/33) OF ZAP0200ONE4XI *** FAILED TO SET key2message AT LAYER 0010: ", key0200one) 
                    
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B18A/33) OF ZAP0200ONE4XI - TRYING TO SET key2actor: ", kb0200one [key0200one]  [key2sense] )     #                
            try:                             
                kb0200one2put [key0200one] [key2sense] [key2actor] = kb0200one [key0200one]  [key2sense] [key2actor]                # ACTOR 
                if ack2dragontrace is True:
                    message2print = "{(Step 6B18B/33) set" + "; actor-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2actor])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #            
            except:
                try:
                    kb0200one2put [key0200one] [key2sense] [key2actor] = 'zap0200one4xi'                             # THIS BECOMES THE ACTOR!
                    message2print = "{(Step 6B18C/33) set" + "; actor-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2actor])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                except:                            
                    print("\n (Step 6B18Z/33) OF ZAP0200ONE4XI *** FAILED TO SET key2actor AT LAYER 0010: ", key0200one)
                    # 
                
                
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B19A/33) OF ZAP0200ONE4XI - TRYING TO SET key2type: ", kb0200one [key0200one]  [key2sense] )      #               
            try:                             
                kb0200one2put [key0200one] [key2sense] [key2type] = kb0200one [key0200one]  [key2sense] [key2type]                  # TYPE 
                if ack2dragontrace is True:
                    message2print = "{(Step 6B19B/33) set" + "; type-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2type])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #                
            except:
                try:
                    kb0200one2put [key0200one] [key2sense] [key2type] = 1                                                 # function
                    message2print = "{(Step 6B19B/33) set" + "; type-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2type])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                              # TYPE               
                except:
                    print("\n (Step 6B19Z/33) OF ZAP0200ONE4XI *** FAILED TO SET key2type AT LAYER 0010: ", key0200one)   # 
                    # 
                    
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B20A/33) OF ZAP0200ONE4XI - TRYING TO SET key2reason: ", kb0200one [key0200one]  )                #                     
            try:                              
                kb0200one2put [key0200one] [key2reason] = kb0200one [key0200one] [key2reason]                                       # REASON
                if ack2dragontrace is True:
                    message2print = "{(Step 6B4A/33) set" + "; reason-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2reason])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #                 
            except:
                print("\n (Step 6B20B/33) OF ZAP0200ONE4XI *** FAILED TO SET key2reason AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B21A/33) OF ZAP0200ONE4XI - TRYING TO SET key2ace: ", kb0200one [key0200one]   )                  #                 
            try:                             
                kb0200one2put [key0200one] [key2ace]    = kb0200one [key0200one] [key2ace]                                          # ACE
                if ack2dragontrace is True:
                    message2print = "{(Step 6B4A/33) set" + "; ace-of-zap-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2ace])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  #                
            except:
                print("\n (Step 6B21B/33) OF ZAP0200ONE4XI *** FAILED TO SET key2ace AT LAYER 0200 TO QUEUE0200ONE: ", key0200one)
                
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
            if ack2debug is True:
                print("\n (Step 6B22A/33) OF ZAP0200ONE4XI - TRYING TO SET key2actor: ", kb0200one [key0200one]  [key2sense] )     #                     
                                                                                              
            try:
                key2try = kb0200one [key0200one]  [key2sense] [key2actor]
                if ack2debug is True:
                    print("\n (Step 6B22B/33) OF ZAP0200ONE4XI - KEY2TRY: ", key2try) 
                    
                kb0200one2put [key0200one] [key2sense] [key2module] = ModuleKB2Zap4Xi[key2try]                                   
                
                if ack2dragontrace is True:
                    message2print = "{(Step 6B22B/33) set" + "; module-set-by-zap0200one4xi to: " + str(kb0200one2put [key0200one] [key2sense] [key2module])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                                                  # 

            except:
                try:
                    kb0200one2put [key0200one] [key2sense] [key2module] = 'zap0200one4xi.py'                        # MODULE IN EXCEPTIONS
                    print("\n (Step 6B22Z1/33) OF ZAP0200ONE4XI ** YIELDED - SET MODULE TO: ", kb0200one2put [key0200one] [key2sense] [key2module])
                    message2print = "{(Step 6B22Z1/33) yielded" + "; module-yielded-by-zap2actor4xi: " + str(kb0200one2put [key0200one] [key2sense] [key2module])  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                          
                except:    
                    print("\n (Step 6B22Z2/33) OF ZAP0200ONE4XI *** FAILED TO SET key2module AT LAYER 0010 ***")              #  
                    #                                                                              
 
            # ---------------------------------------------------------------------------------------------------------------------- 
            # 
            # ----------------------------------------------------------------------------------------------------------------------                 
        else:
            pass
            
    # -------------------------------------------------------------------------------------------------
    # (Step 7/33) BUILD LINK LIST AT AT LAYER 0200 OF DIRECTION ONE 
    # -------------------------------------------------------------------------------------------------               
    if ack2debug is True:
        print("\n (Step 7A/33) OF ZAP0200ONE4XI - TRYING TO BUILD ORDER KNOWLEDGEBASE AT LAYER 0200 OF DIRECTION ONE FROM : ", kb0200one2put)
                                                                                                                                    # 
                                                                                                                                    # 
                                                                                                                                    # 

    try:                             
        keys0200one2put = kb0200one2put.keys()                                                                                      # 
        kb0200link4one = {} 
        order2link = 1
        for key0200one2put in keys0200one2put:
            key0200navigation4one = kb0200one2put [key0200one2put] [key2sense] [key2fire]                                           # input nodes embed fire number 
            kb0200link4one [order2link] = {}
            kb0200link4one [order2link] [key0200one2put] = {}
            kb0200link4one [order2link] [key0200one2put] [1]    = 0                                                                 # order                                                                                                                                 
            kb0200link4one [order2link] [key0200one2put] [2]    = '0x0y0z'                                                          # home                                                           
            kb0200link4one [order2link] [key0200one2put] [3]    = '0x0y0z'                                                          # previous
            kb0200link4one [order2link] [key0200one2put] [4]    = '0x0y0z'                                                          # next
            kb0200link4one [order2link] [key0200one2put] [5]    = '0x0y0z'                                                          # last
            kb0200link4one [order2link] [key0200one2put] [6]    = '0x0y0z'                                                          # first
            kb0200link4one [order2link] [key0200one2put] [7]    = 0                                                                 # fire number
            order2link = order2link + 1
            
        keys0200link4one = kb0200link4one.keys()                                                                                    # keys of input knowledgebase
        if ack2debug is True:
            for key0200link4one in sorted(keys0200link4one):                                                                        # keys of linklist
                if ack2debug is True:
                    print("\n (Step 7B/33) OF ZAP0200ONE4XI KB0200LINK4ONE[", key0200link4one, "]: ", kb0200link4one[key0200link4one])
                                                                                                                                    # 
                                                                                                                                    # 
                                                                                                                                    # 
    except:
        print("\n (Step 7D/33) OF ZAP0200ONE4XI *** FAILED TO BUILD ORDER KNOWLEDGEBASE AT LAYER 0200 OF DIRECTION ONE: ", kb0200link4one) 
        if ack2dragontrace is True:
            message2print = "{(Step 7E/33) failed" + "; kb0200link4one-failed-by-zap0200one4xi: " + str(kb0200link4one) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
        
    # -------------------------------------------------------------------------------------------------
    # (Step 8A/33) BUILD FIRE LIST
    # -------------------------------------------------------------------------------------------------                       
    if ack2debug is True:
        print("\n (Step 8A1/33) OF ZAP0200ONE4XI - TRYING BUILD FIRE KNOWLEDGEBASE")
    try:
        kb0200fire4one = {}
        keys0200one2put = kb0200one2put.keys()                                                                                      #     
        for key0200one2put in keys0200one2put:
            key0200fire4one = kb0200one2put [key0200one2put] [key2sense] [key2fire]                                                 # 
            kb0200fire4one[key0200fire4one] = key0200one2put                                                                        # 
        if ack2debug is True:
            print("\n (Step 8A2/33) OF ZAP0200ONE4XI - BUILT FIRE KNOWLEDGEBASE: ", kb0200fire4one)                                 #        
    except:
        print("\n (Step 8A3/33) OF ZAP0200ONE4XI *** FAILED BUILD FIRE KNOWLEDGEBASE")
        if ack2dragontrace is True:
            message2print = "{(Step 8Z/33) failed" + "; kb0200fire4one-failed-by-zap0200one4xi: " + str(kb0200fire4one) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
       
    # -----------------------------------------------------------------------------------------------------------------------------
    # (Step 8C/33) EMBED FIRES TO LINK LIST  
    # -----------------------------------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 8C1/33) OF ZAP0200ONE4XI - TRYING TO EMBED FIRES TO KNOWLEDGEBASE AT LAYER 0200 OF DIRECTION ONE")     

    keys2fire = kb0200fire4one.keys()
    rank2xi = 1
    for key2fire in sorted(keys2fire):                                                                                              #                                                                    
        # -------------------------------------------------------------------------------------------------------------------------
        # 
        # -------------------------------------------------------------------------------------------------------------------------                                                                                     
        if ack2debug is True:
            print("\n (Step 8C5/33) OF ZAP0200ONE4XI - KEY2FIRE: ", key2fire)                                                       # 

        coordinate2rank = kb0200fire4one[key2fire]                                                                                  #                                                                 
        
        
        keys2link = kb0200link4one.keys()                                                                                           
        for keylink in keys2link:                                                                                                   # 
            try:
                if kb0200link4one [keylink] [coordinate2rank]  [7] == 0:            
                    kb0200link4one [keylink] [coordinate2rank] [7] = key2fire                                                       # 
                if kb0200link4one [keylink] [coordinate2rank]  [1] == 0:
                    kb0200link4one [keylink] [coordinate2rank] [1] = rank2xi                                                        # 
                    rank2xi = rank2xi + 1
                if ack2debug is True:    
                    print("\n (Step 8D10/33) OF ZAP0200ONE4XI - MATCH: UPDATED KB0200LINK4ONE: ", kb0200link4one)                   # 
                                                                                                                                    # 
                                                                                                                                    # 
            except:
                pass               

    
    # ---------------------------------------------------------------------------------------------------------------------
    # (Step 8D/33) PRINT LINKING LIST WITH ONE FIRE EMBEDDED  
    # ---------------------------------------------------------------------------------------------------------------------                    
    if ack2debug is True:
        print("\n (Step 8D1/33) OF ZAP0200ONE4XI - TRYING TO PRINT LINKING LIST WITH ONE FIRE EMBEDDED ")   
        try: 
            print("\n (Step 8C7/33) OF ZAP0200ONE4XI - KB0200LINK4ONE: ", kb0200link4one)                                           # 
        except:                                                                                                                         
            print("\n (Step 8Z4/33) OF ZAP0200ONE4XI *** FAILED TO PRINT LINKING LIST WITH ONE FIRE EMBEDDED") 
                        
            
    # -------------------------------------------------------------------------------------------------
    # (Step 8E/33) EMBED FIRES TO KNOWLEDGEBASE AT LAYER 0200 OF DIRECTION ONE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 8D1/33) OF ZAP0200ONE4XI - TRYING TO EMBED FIRES TO KNOWLEDGEBASE OF LAYER 0200 OF DIRECTION ONE")      
                                                                                                                           
    keys0200one2put = kb0200one2put.keys()
                                               
    # -------------------------------------------------------------------------------------------------
    # THE LATEST VALUES TO BE CHANGED DURING WALKTROUGHS
    # -------------------------------------------------------------------------------------------------     
    origin2link         = '0x0y0z'                                                                                                  # link to origin
    home2link           = '-0x-0y-0z'                                                                                               # unresolved-home  
    previous2link       = '-0x-0y-0z'                                                                                               # unresolved-previous 
    next2link           = '+0x+0y+0z'                                                                                               # unresolved-next 
    first2link          = '+0x+0y+0z'                                                                                               # unresolved-first 
    last2link           = '+0x+0y+0z'                                                                                               # unresolved-last 
    max2last            = 0                                                                                                         # maximun order number for the last node - default 0

                                                                                                             
    # -------------------------------------------------------------------------------------------------
    # (Step 8E1/33) THE FIRST WALKTROUGH TO EMBED FIRES TO KNOWLEDGEBASE OF LAYER 0200 OF DIRECTION ONE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 8E1a/33) OF ZAP0200ONE4XI - TRYING THE FIRST WALKTROUGH TO EMBED FIRES TO KNOWLEDGEBASE OF LAYER 0200 OF DIRECTION ONE")               
    for key0200one2put in keys0200one2put:
        # -------------------------------------------------------------------------------------------------
        # KNOWLEDGEBASE AT LAYER 0200 OF DIRECTION ONE
        # -------------------------------------------------------------------------------------------------                                                                                      
        if ack2debug is True:
            print("\n (Step 8E1b/33) OF ZAP0200ONE4XI KB0200LINK4ONE - KEY0200ONE2PUT: ", key0200one2put)                           # 
        keys2link = kb0200link4one.keys()
        for key2link in keys2link:
            if ack2debug is True:
                print("\n (Step 8E1c/33) OF ZAP0200ONE4XI KB0200LINK4ONE - KEY2LINK: ", key2link)                                   # 
            # ---------------------------------------------------------------------------------------------
            # LINK LIST AT LAYER 0200 OF DIRECTION ONE
            # ---------------------------------------------------------------------------------------------          
            try:
                kb2check = kb0200link4one[key2link]
                keys2check = kb2check.keys()
                for key2check in keys2check:
                    # ---------------------------------------------------------------------------------------------
                    # NODE(S) OF LINK LIST AT LAYER 0200 OF DIRECTION ONE
                    # -------------------------------------------------------------------------------------------                   
                    if key2check == key0200one2put: 
                        if ack2debug is True:
                            print("\n (Step 8E1d/33) OF ZAP0200ONE4XI KB0200LINK4ONE - MATCH WITH KEY0200ONE2PUT: ", key0200one2put)    #                                                                        
                        if kb0200link4one[key2link] [key0200one2put] [1] == 1:                                                          # the first none in fire order at this layer to required direction
                            if ack2debug is True:
                                print("\n (Step 8E1e/33) OF ZAP0200ONE4XI KB0200LINK4ONE - THE FIRT NODE: ", key0200one2put)            # THE FIRT NODE:  
                                  
                            # ---------------------------------------------------------------------------------
                            # SET LINKS OF THE FIRST NODE
                            # ---------------------------------------------------------------------------------                                                                              
                            first2link        = key0200one2put                                                                          # first-link points to this node                        
                            if ack2debug is True:
                                print("\n (Step 8E1f/33) OF ZAP0200ONE4XI KB0200LINK4ONE - SET FIRST2LINK TO: ", first2link)            
                                
                            # ---------------------------------------------------------------------------------
                            # EMBED LINKS OF THE FIRST NODE
                            # ---------------------------------------------------------------------------------                                                    
                            kb0200one2put [key0200one2put] [key2sense] [key2home]     = home2link                                       # 
                                                                     
                                                     
                            # ---------------------------------------------------------------------------------
                            # UPDATE AFTER THE FIRST NODE
                            # --------------------------------------------------------------------------------- 
                            if kb0200link4one[key2link] [key0200one2put] [1] > max2last:
                                last2link    = key0200one2put                                                                           # 
                                max2last     = kb0200link4one[key2link] [key0200one2put] [1]                                            # 
                        else:
                            if ack2debug is True:
                                print("\n (Step 8E1g/33) OF ZAP0200ONE4XI KB0200LINK4ONE - THE ", kb0200link4one[key2link] [key0200one2put] [1], ". NODE: ", key0200one2put)
                                                                                                                                        # 
                                                                                                                                        #       
                            # ---------------------------------------------------------------------------------
                            # SET LINKS OF TYPICAL NODE
                            # ---------------------------------------------------------------------------------
                                                                                                                                        # none can be set in this pass!
                            
                            # ---------------------------------------------------------------------------------
                            # EMBED LINKS OF TYPICAL NODE
                            # ---------------------------------------------------------------------------------                                                    
                            kb0200one2put [key0200one2put] [key2sense] [key2home]     = home2link                                       # only link to be updated for output!

                            # ---------------------------------------------------------------------------------
                            # UPDATE AFTER TYPICAL NODE 
                            # --------------------------------------------------------------------------------- 
                            if kb0200link4one[key2link] [key0200one2put] [1] > max2last:
                                last2link    = key0200one2put                                                                           # 
                                max2last     = kb0200link4one[key2link] [key0200one2put] [1]                                            #                     
                                                      
                           
                    else:
                        if ack2debug is True:
                            print("\n (Step 8E1h/33) OF ZAP0200ONE4XI KEY0200ONE2PUT - PASSED KEY2LINK: ", key2link, " WITH NODE: ", key0200one2put)              
            except:
                pass                                                                                                                    # nodes with different links
    # -------------------------------------------------------------------------------------------------
    # 
    # -------------------------------------------------------------------------------------------------                                  
    if ack2debug is True:
        
        print("\n (Step 8E1i/33) OF ZAP0200ONE4XI - LATEST FIRST: ", first2link)                                                        # 
        print("\n (Step 8E1j/33) OF ZAP0200ONE4XI - LATEST LAST: ", last2link)                                                          #                             
        print("\n (Step 8E1k/33) OF ZAP0200ONE4XI - LATEST MAX ORDER: ",max2last)                                                       #            
                
    # -------------------------------------------------------------------------------------------------
    # (Step 9/33) THE SECOND WALKTROUGH TO EMBED THE FIRST AND LAST LINK TO KNOWLEDGEBASE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 9A/33) OF ZAP0200ONE4XI - TRYING TO EMBED THE FIRST AND LAST LINK  TO KNOWLEDGEBASE OF LAYER 0200 OF DIRECTION ONE")
    try:      
        for key0200one2put in keys0200one2put:
            # ---------------------------------------------------------------------------------------------
            # KNOWLEDGEBASE AT LAYER 0200 OF DIRECTION ONE
            # ---------------------------------------------------------------------------------------------    
            kb0200one2put [key0200one2put] [key2sense] [key2first] = first2link
            kb0200one2put [key0200one2put] [key2sense] [key2last]  = last2link
        # ------------------------------------------------------------------------------------------------- 
        #
        # -------------------------------------------------------------------------------------------------             
        if ack2debug is True:    
            print("\n (Step 9B/33) OF ZAP0200ONE4XI - UPDATED THE FIRST AND LAST LINK TO KNOWLEDGEBASE OF LAYER 0200 OF DIRECTION ONE")
            print("\n (Step 9C/33) OF ZAP0200ONE4XI - KB0200ONE2PUT: ", kb0200one2put)
            # 
 
    except:        
        print("\n (Step 9Z/33) OF ZAP0200ONE4XI *** FAILED TO EMBED THE FIRST AND LAST LINK  TO KNOWLEDGEBASE OF LAYER 0200 OF DIRECTION ONE")
        if ack2dragontrace is True:
            message2print = "{(Step 9Z/33) failed" + "; kb0200one2put-failed-by-zap0200one4xi: " + str(kb0200one2put) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                  
    # -------------------------------------------------------------------------------------------------
    # (Step 10/33) THE THIRD WALKTROUGH TO EMBED PREVIOUS LINKS TO KNOWLEDGEBASE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 10A/33) OF ZAP0200ONE4XI - TRYING TO EMBED PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0200 OF DIRECTION ONE")
    try:    
        # 
        
        keys2link = kb0200link4one.keys()
        for key2link in keys2link:
            if ack2debug is True:
                print("\n (Step 10B/33) OF ZAP0200ONE4XI KB0200LINK4ONE - KEY2LINK: ", key2link)                                    # 
            # ---------------------------------------------------------------------------------------------------
            # LINK LIST AT LAYER 0200 OF DIRECTION ONE
            # ---------------------------------------------------------------------------------------------------          
            try:
                kb2check = kb0200link4one[key2link]                                                                                 # 
                keys2check = kb2check.keys()                                                                                        # 
                for key2check in keys2check: 
                                                                                                       #  '0x0y19z'
                    # -------------------------------------------------------------------------------------------
                    # PREVIOUS LINK
                    # -------------------------------------------------------------------------------------------                                                                                                                                             
                    if kb2check [key2check] [1] == 1:                                                                               # 1 = the first node
                        # ---------------------------------------------------------------------------------------
                        # FIRST NODE - UNRESOLVED-PREVIOUS FOR THE MAIN TO SOLVE FROM PREVIOUS LAYER LAST 
                        # ---------------------------------------------------------------------------------------
                        kb0200one2put [key2check] [key2sense] [key2previous] = previous2link                                        # '-0x-0y-0z' i.e. unresolved-previous for the main to solve from previous layer last 
                        if ack2debug is True:
                            print("\n (Step 10C/33) OF ZAP0200ONE4XI - PREVIOUS SET TO: ", previous2link, "  FOR THE FIRST NODE: ", key2check)
                                                                                                                                    # 
                    else:
                        # ---------------------------------------------------------------------------------------
                        # PREVIOUS TO OTHERS
                        # ---------------------------------------------------------------------------------------                 
                        order2previous = kb2check [key2check] [1] - 1                                                               # 
                        if ack2debug is True:
                            print("\n (Step 10D/33) OF ZAP0200ONE4XI ORDER OF PREVIOUS TO HUNT: ", order2previous, "  FOR NODE: ", key2check)
                                                                                                                                    # 
                                                                                                                                    # 
                        keys2hunt1 = kb0200link4one.keys()                                  
                        for key2hunt1 in keys2hunt1:                                                                                # 
                            # -----------------------------------------------------------------------------------
                            # HUNT PREVIOUS
                            # -----------------------------------------------------------------------------------
                            kb2check4hunt1 = kb0200link4one[key2hunt1]                                                              #  
                            keys2check4hunt1 = kb2check4hunt1.keys()                                                                # 
                            for key2check4hunt1 in keys2check4hunt1:
                                if kb2check4hunt1 [key2check4hunt1] [1] == order2previous:                                          # 
                                    kb0200one2put [key2check] [key2sense] [key2previous] = key2check4hunt1                          # 
                                    if ack2debug is True:
                                        print("\n (Step 10E/33) OF ZAP0200ONE4XI - PREVIOUS SET TO: ", key2check4hunt1, "  FOR NODE: ", key2check)
                                                                                                                                    # 
                                                                                                                                    # 
                            else:
                                pass

            except:        
                pass                    
        # ------------------------------------------------------------------------------------------------- 
        #
        # ------------------------------------------------------------------------------------------------- 
        # input link list:
        # 
        #     key2home        = 14
        #     key2previous    = 15 <-- FOCUS!
        #     key2next        = 16
        #     key2last        = 17
        #     key2first       = 18                                                
        if ack2debug is True:    
            print("\n (Step 10B/33) OF ZAP0200ONE4XI - UPDATED PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0200 OF DIRECTION ONE")
            print("\n (Step 10C/33) OF ZAP0200ONE4XI - KB0200ONE2PUT: ", kb0200one2put)
            # 
            
    except:        
        print("\n (Step 10Z2/33) OF ZAP0200ONE4XI *** FAILED TO EMBED PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0200 OF DIRECTION ONE")
        if ack2dragontrace is True:
            message2print = "{(Step 10Z/33) failed" + "; kb0200one2put-failed-by-zap0200one4xi: " + str(kb0200one2put) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)        
    # -------------------------------------------------------------------------------------------------
    # (Step 11/33) THE THIRD WALKTROUGH TO EMBED NEXT LINKS TO KNOWLEDGEBASE
    # -------------------------------------------------------------------------------------------------         
    if ack2debug is True:
        print("\n (Step 11A/33) OF ZAP0200ONE4XI - TRYING TO EMBED NEXT LINKS TO KNOWLEDGEBASE OF LAYER 0200 OF DIRECTION ONE")
    try:
        # input link list:    
        # 
        
        keys2link = kb0200link4one.keys()
        for key2link in keys2link:
            if ack2debug is True:
                print("\n (Step 11B/33) OF ZAP0200ONE4XI KB0200LINK4ONE - KEY2LINK: ", key2link)                                    # 
            # ---------------------------------------------------------------------------------------------------
            # LINK LIST AT LAYER 0200 OF DIRECTION ONE
            # ---------------------------------------------------------------------------------------------------          
            try:
                kb2check = kb0200link4one[key2link]                                                                                 # 
                keys2check = kb2check.keys()                                                                                        #  

                for key2check in keys2check:                 
                    # -------------------------------------------------------------------------------------------
                    # NEXT LINK
                    # -------------------------------------------------------------------------------------------                                 
                    if kb2check [key2check] [1] == max2last:
                        # ---------------------------------------------------------------------------------------
                        # LAST NODE - UNRESOLVED-NEXT FOR THE MAIN TO SOLVE FROM NEXT LAYER FIRST
                        # --------------------------------------------------------------------------------------- 
                        kb0200one2put [key2check] [key2sense] [key2next] = next2link                                                # 
                        if ack2debug is True:
                            print("\n (Step 11F/33) OF ZAP0200ONE4XI - NEXT SET TO: ", next2link, "  FOR LAST NODE: ", key2check)
                                                                                                                                    #                    
                    else:
                        # ---------------------------------------------------------------------------------------
                        # NEXT TO OTHERS
                        # ---------------------------------------------------------------------------------------                     
                        order2next = kb2check [key2check] [1] + 1                                                                   # 
                        if ack2debug is True:
                            print("\n (Step 11E/33) OF ZAP0200ONE4XI ORDER OF NEXT TO HUNT: ", order2next, "  FOR NODE: ", key2check)
                                                                                                                                    # 
                                                                                                                                    #                      
                        keys2hunt2 = kb0200link4one.keys()                         
                        for key2hunt2 in keys2hunt2:
                            # -----------------------------------------------------------------------------------
                            # HUNT NEXT
                            # -----------------------------------------------------------------------------------
                            kb2check4hunt2 = kb0200link4one[key2hunt2] 
                            keys2check4hunt2 = kb2check4hunt2.keys()
                            for key2check4hunt2 in keys2check4hunt2: 
                                if kb2check4hunt2 [key2check4hunt2] [1] == order2next:                                                
                                    kb0200one2put [key2check] [key2sense] [key2next] = key2check4hunt2                              # 
                                    if ack2debug is True:
                                        print("\n (Step 11G/33) OF ZAP0200ONE4XI - NEXT SET TO: ", key2check4hunt2, "  FOR NODE: ", key2check)
                                                                                                                                    #            
                                else:
                                    pass
            except:        
                pass                    
        # ------------------------------------------------------------------------------------------------- 
        #
        # ------------------------------------------------------------------------------------------------- 
        # input link list:
        # 
        #     key2home        = 14
        #     key2previous    = 15
        #     key2next        = 16 <-- FOCUS!
        #     key2last        = 17
        #     key2first       = 18                                                    
        if ack2debug is True:    
            print("\n (Step 11B/33) OF ZAP0200ONE4XI - UPDATED NEXT LINKS TO KNOWLEDGEBASE OF LAYER 0200 OF DIRECTION ONE")
            print("\n (Step 11C/33) OF ZAP0200ONE4XI - KB0200ONE2PUT: ", kb0200one2put)
            # 
            
    except:        
        print("\n (Step 10Z2/33) OF ZAP0200ONE4XI *** FAILED TO EMBED NEXT AND PREVIOUS LINKS TO KNOWLEDGEBASE OF LAYER 0200 OF DIRECTION ONE")
        if ack2dragontrace is True:
            message2print = "{(Step 10Z2/33) failed" + "; kb0200one2put-failed-by-zap0200one4xi: " + str(kb0200one2put) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                                
    # -------------------------------------------------------------------------------------------------
    # (Step 21/33) PUT KNOWLEDGEBASE FOR LAYER 0200 OF DIRECTION ONE 
    # -------------------------------------------------------------------------------------------------                   
    try:
        queue0200one.put(kb0200one2put)
        ack0200put4one = True  
        if ack2debug is True:                                                                                                       
            print("\n (Step 21A/33) OF ZAP0200ONE4XI - SUCCEEDED TO PUT LAYER 0200 TO QUEUE: ", queue0200one, " KB2PUT: ", kb0200one2put)
                                                                                                                                    # {}  
       
        # minimize trace after module test:
        if ack2dragontrace is True:
            message2print = "{(Step 21B/33) put" + "; kb0200one2put-put-by-zap0200one4xi: " + str(kb0200one2put)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'0x2y199z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon0x2y199z', 5: '#9BA2A2', 6: 289, 7: 1, 8: Decimal('199.010049997'), 9: Decimal('0'), 10: 1, 11: '{returning; set-close-process4xi-returning: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_close_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '0x25y198z', 16: '107x103y133z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '0x132y149z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon0x132y149z', 5: '#9BA2A2', 6: 281, 7: 1, 8: Decimal('199.060292374'), 9: Decimal('0'), 10: 1, 11: '{passed; set-all-process4xi-param-passed-to-set-all-process4xi: 1; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_all_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '0x0y199z', 16: '0x4y199z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '115x90y136z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon115x90y136z', 5: '#9BA2A2', 6: 299, 7: 1, 8: Decimal('199.551998236'), 9: Decimal('0'), 10: 1, 11: '{passed; set-unknown-process4xi-param-passed-to-set-unknown-process4xi: unknown; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_unknown_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '114x132y96z', 16: '+0x+0y+0z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '0x8y199z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon0x8y199z', 5: '#9BA2A2', 6: 284, 7: 1, 8: Decimal('199.160739103'), 9: Decimal('0'), 10: 1, 11: '{set; run-process4xi-set-by-set-run-process4xi to: 0; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_run_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '0x6y199z', 16: '101x145y92z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '107x103y133z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon107x103y133z', 5: '#9BA2A2', 6: 290, 7: 1, 8: Decimal('199.366496684'), 9: Decimal('0'), 10: 1, 11: '{started; set-terminate-process4xi-started: function set_terminate_process4xi at 0x02AA9C48; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_terminate_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '0x2y199z', 16: '108x139y94z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '111x97y134z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon111x97y134z', 5: '#9BA2A2', 6: 293, 7: 1, 8: Decimal('199.213453361'), 9: Decimal('0'), 10: 1, 11: '{returning; set-terminate-process4xi-returning: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_terminate_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '110x123y111z', 16: '102x110y131z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '0x180y87z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon0x180y87z', 5: '#9BA2A2', 6: 286, 7: 1, 8: Decimal('199.922484979'), 9: Decimal('0'), 10: 1, 11: '{started; set-close-process4xi-started: function set_close_process4xi at 0x02AA9B70; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_close_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '101x145y92z', 16: '0x23y198z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '108x139y94z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon108x139y94z', 5: '#9BA2A2', 6: 291, 7: 1, 8: Decimal('199.551998236'), 9: Decimal('0'), 10: 1, 11: '{passed; set-terminate-process4xi-param-passed-to-set-terminate-process4xi: 2; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_terminate_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '107x103y133z', 16: '110x123y111z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '114x132y96z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon114x132y96z', 5: '#9BA2A2', 6: 298, 7: 1, 8: Decimal('199.087920276'), 9: Decimal('0'), 10: 1, 11: '{started; set-unknown-process4xi-started: function set_unknown_process4xi at 0x02AA9DF8; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_unknown_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '105x71y154z', 16: '115x90y136z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '0x0y199z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon0x0y199z', 5: '#9BA2A2', 6: 280, 7: 1, 8: Decimal('199.0'), 9: Decimal('-1'), 10: 1, 11: '{started; set-all-process4xi-started: function set_all_process4xi at 0x02AAD198; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_all_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '-0x-0y-0z', 16: '0x132y149z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '101x145y92z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon101x145y92z', 5: '#9BA2A2', 6: 285, 7: 1, 8: Decimal('199.223492591'), 9: Decimal('0'), 10: 1, 11: '{returning; set-run-process4xi-returning: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_run_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '0x8y199z', 16: '0x180y87z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '102x77y152z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon102x77y152z', 5: '#9BA2A2', 6: 295, 7: 1, 8: Decimal('198.587512196'), 9: Decimal('-1'), 10: 1, 11: '{passed; set-started-process4xi-param-passed-to-set-started-process4xi: started; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_started_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '102x110y131z', 16: '105x130y109z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '105x130y109z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon105x130y109z', 5: '#9BA2A2', 6: 296, 7: 1, 8: Decimal('199.514410507'), 9: Decimal('0'), 10: 1, 11: '{set; started-process4xi-set-by-set-started-process4xi to: started; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_started_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '102x77y152z', 16: '105x71y154z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '102x110y131z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon102x110y131z', 5: '#9BA2A2', 6: 294, 7: 1, 8: Decimal('199.160739103'), 9: Decimal('0'), 10: 1, 11: '{started; set-started-process4xi-started: function set_started_process4xi at 0x02AA9D20; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_started_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '111x97y134z', 16: '102x77y152z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '105x71y154z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon105x71y154z', 5: '#9BA2A2', 6: 297, 7: 1, 8: Decimal('199.454255407'), 9: Decimal('0'), 10: 1, 11: '{returning; set-started-process4xi-returning: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_started_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '105x130y109z', 16: '114x132y96z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '110x123y111z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon110x123y111z', 5: '#9BA2A2', 6: 292, 7: 1, 8: Decimal('198.871818014'), 9: Decimal('-1'), 10: 1, 11: '{set; terminate_process4xi-set-by-set-terminate-process4xi to: 2; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_terminate_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '108x139y94z', 16: '111x97y134z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '0x25y198z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon0x25y198z', 5: '#9BA2A2', 6: 288, 7: 1, 8: Decimal('199.57204213'), 9: Decimal('0'), 10: 1, 11: '{set; close-process4xi-set-by-set-close-process4xi to: 1; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_close_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '0x23y198z', 16: '0x2y199z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '0x4y199z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon0x4y199z', 5: '#9BA2A2', 6: 282, 7: 1, 8: Decimal('199.040196945'), 9: Decimal('0'), 10: 1, 11: '{started; set-run-process4xi-started: function set_run_process4xi at 0x02AA9A98; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_run_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '0x132y149z', 16: '0x6y199z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '0x6y199z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon0x6y199z', 5: '#9BA2A2', 6: 283, 7: 1, 8: Decimal('199.090431714'), 9: Decimal('0'), 10: 1, 11: '{passed; set-run-process4xi-param-passed-to-set-run-process4xi: 0; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_run_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '0x4y199z', 16: '0x8y199z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}},
            #  '0x23y198z': {'2xi': {1: 1, 2: 200, 3: {1: 62831.853071795864, 2: '#848484', 3: 20, 4: 3141.5926535897934}, 4: 'dragon0x23y198z', 5: '#9BA2A2', 6: 287, 7: 1, 8: Decimal('199.331382376'), 9: Decimal('0'), 10: 1, 11: '{passed; set-close-process4xi-param-passed-to-set-close-process4xi: 1; time: 08:11:13 10/21/10 Pacific Daylight Time}', 12: 'set_close_process4xi', 13: 1, 14: '-0x-0y-0z', 15: '0x180y87z', 16: '0x25y198z', 17: '115x90y136z', 18: '0x0y199z', 19: 'constant_process4xi.py'}, '8xi': {}, '4xi': {}}}; time: 09:27:32 12/20/10 Pacific Standard Time}
         
                    
    except:                                                                                                                
        print("\n (Step 21C/33) OF ZAP0200ONE4XI *** FAILED TO SET LAYER 0200 TO QUEUE0200ONE: ", queue0200one, " KB2PUT: ", kb0200one2put)                                                                                                          #  
        if ack2dragontrace is True:
            message2print = "{(Step 21C/33) failed" + "; queue0200one-put-failed-by-zap0200one4xi: " + str(queue0200one.put) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
    # -------------------------------------------------------------------------------------------------
    # (Step 20/33) MESSAGE ABOUT PUT OF KNOWLEDGEBASE FOR LAYER 0200 OF DIRECTION ONE 
    # -------------------------------------------------------------------------------------------------   
    if ack2debug is True:
        print("\n (Step 20A/33) OF ZAP0200ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL0200ONE: ", publisher_channel0200one)
                                                                                                                                    # 
    if ack0200put4one is True:
        message2send4one = "<ack0200put4one4xi>layer0200one</ack0200put4one4xi>"
    else:
        message2send4one = "<nack0200put4one4xi>layer0200one</nack0200put4one4xi>" 
    if ack2dragontrace is True:
        message2print = "{(Step 20B/33) set" + "; message2send4one-set-by-zap0200one4xi to: " + str(message2send4one)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                                              #         
                
    # -------------------------------------------------------------------------------------------------
    # (Step 21/33) SEND MESSAGE ABOUT PUT OF KNOWLEDGEBASE FOR LAYER 0200 OF DIRECTION ONE 
    # -------------------------------------------------------------------------------------------------                        
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        publisher_channel0200one.send(message2send4one)
        if ack2debug is True:     
            print("(Step 21A/33) OF ZAP0200ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel0200one, " - TIME: ", time4xi()) 
                                                                                                                                    # <ack0200put4one4xi>layer0200one</ack0200put4one4xi>
        if ack2dragontrace is True:
            message2print = "{(Step 21B/33) sent" + "; message2send4one-sent-by-zap0200one4xi: " + str(message2send4one)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                          #     
    except:
        print("(Step 21C/33) OF ZAP0200ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel0200one, " - TIME: ", time4xi()) 
        if ack2dragontrace is True:
            message2print = "{(Step 21C/33) failed" + "; message2send4one-failed-by-zap0200one4xi: " + str(message2send4one) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                          # 
         
    # -------------------------------------------------------------------------------------------------
    # (Step 22/33) RETURN QUEUE OF LAYER 0200 OF DIRECTION ONE 
    # -------------------------------------------------------------------------------------------------               
    if ack2debug is True:        
        print("\n (Step 22A/33) OF ZAP0200ONE4XI - RETURNING QUEUE OBJECT QUEUE0200ONE: ", queue0200one, " - TIME: ", time4xi()) 
         
    if ack2dragontrace is True:
        message2print = "{(Step 22B/33) returning" + "; queue0200one-returning-by-zap0200one4xi: " + str(queue0200one) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                                              # 
        
    return queue0200one    
        
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   zap2actor4xi.py
#   test_zap2actor4xi.py
#   test_zap2actor4xi.txt
#   sense-test-zap2actor4xi.xml
#   reason-test-zap2actor4xi.xml
#   ace-test-zap2actor4xi4xi.xml
#   scope-sense*4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of zap0200one4xi.py                          
# ------------------------------------------------------------------------------------------------- 
#"
#/>
